/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPORECE                                                 */
/* Tabela : TIPORECE                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TIPORECE' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_TIPORECE
GO

CREATE TRIGGER DTULTATU_TIPORECE
ON TIPORECE
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TIPORECE', null, 'CDTIPORECE='+ CDTIPORECE + ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TIPORECE
      SET DTULTATUTIPR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(TIPORECE.CDTIPORECE ,0) = ISNULL(INSERTED.CDTIPORECE ,0));
   END;
END;
GO

UPDATE TIPORECE SET DTULTATUTIPR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUTIPR IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUTIPR' and
            type = 'D')
   ALTER TABLE TIPORECE DROP CONSTRAINT DEFAULT_DTULTATUTIPR
GO

ALTER TABLE TIPORECE ADD CONSTRAINT DEFAULT_DTULTATUTIPR
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUTIPR
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_TIPORECE','4.11.194';
GO

