function bco21100ExtratoDeMovimentacaoBancariaController(General, ScreenService, templateManager, ZhFilterPreferences) {

    var self = this;

    this.openFilter = function(widget){
        var rowsToSet = {};
        rowsToSet.DTMOVBANC = { 
            start: moment().format('DD/MM/YYYY'),
            end: moment().format('DD/MM/YYYY')
        };
        rowsToSet.P_SALDOINICIAL = "0";
        ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
    };

    self.buildFilter = function (widget, preference) {
        var filterRow = preference.FILTER_ROW;
        
        var filtro = [
            {
                "name": "CDEMPRESA",
                "operator": "=",
                "value": filterRow.CDEMPRESA ? filterRow.CDEMPRESA : 'T'
            },
            {
                "name": "P_SALDOINICIAL",
                "operator": "=",
                "value": filterRow.P_SALDOINICIAL ? filterRow.P_SALDOINICIAL : '0'
            },
            {
                "name": "DTPERIODOINI",
                "operator": "=",
                "value": filterRow.DTMOVBANC.start
            },
            {
                "name": "DTPERIODOFIN",
                "operator": "=",
                "value": filterRow.DTMOVBANC.end
            }
        ];
        
        if(filterRow.CDREDUCONT){
            filtro.push(
                {
                    "name": "CDREDUCONT",
                    "operator": "=",
                    "value": filterRow.CDREDUCONT
                }
            );
        }
        
        widget.dataSourceFilter = filtro; 
        
        widget.reload();
        
    };
    
    /*self.changeDateFields = function(widget) {
        var currentRow = widget.row;
        currentRow.DTPERIODOINI = currentRow.DTMOVBANC.start;
        currentRow.DTPERIODOFIN = currentRow.DTMOVBANC.end;
    };*/

    //Limpa os nomes dos campos invterval do dataSource
    var getDataSourceWithoutIntervalFieldNames = function(filtro){
        for(var i = 0; i < filtro.length; i++) {
            if(filtro[i].name === 'DTMOVBANC') {
                filtro.splice(i, 1);
                i--;
            }
        }
        return filtro;
    };
   
    this.changeHeaderValues = function(widget, data){
        var newFilter = widget.e.metadata.filter;
        
        var correctFilter = [];
        var aux_arr = [];
        var value;
        newFilter.forEach(function(filter){
            if(filter.label == 'Saldo Inicial'){
                data.getField("P_SALDOINICIAL").filterProperties.dataSource.data.forEach(function(saldo){
                    if(saldo.value == filter.value.substr(10,1)){
                        value = saldo.name;
                    }
                });
                filter.value = value+'.'; 
                correctFilter.push(filter);
            } else if(filter.label == 'Data'){
                filter.label = 'Período';
                correctFilter.push(filter);
            }
        });
        
        correctFilter.forEach(function(aux){
            if((aux.value.match(/is equal to/)) || (aux.value.match(/é igual a/))){
                value = aux.value.substr(11);
                aux.value = value;
                aux_arr.push(aux);
            } else if((aux.value.match(/is between/)) || (aux.value.match(/está entre/))){
                value = aux.value.substr(11);
                value = value.replace('e','a');
                aux.value = value;
                aux_arr.push(aux);
            } else {
                aux_arr.push(aux);
            }
        });
        
        correctFilter = aux_arr;
        
        var nmempresa = data.dataSource.data[0].NMEMPRESA;
        
        data.dataSourceFilter.forEach(function(filter){
            if((filter.name == "CDEMPRESA") && (filter.value != "T")){
                correctFilter.push({
                    label: 'EMPRESA',
                    value: filter.value+' - '+nmempresa
                });
            } else if((filter.name == "CDREDUCONT") && filter.value){
                General.callRestEngine(
                    'fin#/contcorr_banco_masks',
                    'FilterData', 
                    [
                        {
                            "name": "CDOPERADOR",
                            "operator": "=",
                            "value": getLocalVar('CDOPERADOR')
                        },
                        {
                            "name": "CDREDUCONT",
                            "operator": "=",
                            "value": filter.value
                        }
                    ]
                ).then(function(response){
                    response = response.dataset.contcorr_banco_masks[0];
                    correctFilter.push({
                        label: 'CONTA CORRENTE',
                        value: (response.CDAGENCIA+'/'+response.CDCONTCORRMASK+' '+response.DSCONTCORR)
                    });
                });
            }
        }.bind(this));
        
        
        widget.e.metadata.filter = correctFilter;    

    };
    
    this.preparaFiltroMovimentacao = function(args) {
    	var widget    = templateManager.container.getWidget('movimentacao_grid');
    	var filterRow = args.e.preference.FILTER_ROW;
    	
    	args.e.preference.FILTER_ROW = {};
    	args.e.preference.CUSTOM_FILTER_ROW = {};
    	
    	General.callRestEngine('fin#/gerarRelatorioMovimentacaoBancaria', 'Row', filterRow).then(function (response) {
    		var nrseqmovbanc = response.dataset.movimentacaoBancaria[0];
    		
    		var filtro = [
    			{
    				"name": "NRSEQMOVBANC",
    				"operator": "=",
    				"value": nrseqmovbanc
    			}
    		];
    		
    		args.e.preference.FILTER_ROW = {"NRSEQMOVBANC" : nrseqmovbanc};
    		widget.dataSourceFilter = filtro;
    		widget.reload();
    	}).catch(function(erro){
    		ScreenService.showMessage(erro.data.error);
    	});
    };

}

Configuration(function (ContextRegister) {
	ContextRegister.register('bco21100ExtratoDeMovimentacaoBancariaController', bco21100ExtratoDeMovimentacaoBancariaController);
});